/* Copyright (C) Emmanuel Varagnat 1998

   Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
   le modifier conformment aux dispositions de la Licence Publique Gnrale
   GNU, telle que publie par la Free Software Foundation ; version 2 de la
   licence, ou encore ( votre choix) toute version ultrieure.

   Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE
   GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION ou
   D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail, voir la Licence
   Publique Gnrale GNU .

   Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en
   mme temps que ce programme ; si ce n'est pas le cas, crivez  la Free
   Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.

  ==========================================================================

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

  ==========================================================================

   Ecrit par Emmanuel Varagnat (emmanuel.varagnat@altavista.net)  */

#include <gtk/gtk.h>

#include "explore.h"
#include "../images/FileManager.xpm"


static void close_info(GtkWidget *widget, GdkEvent *ev, GtkWidget *p) {
	gtk_grab_remove(p);
	gtk_widget_destroy(p);
}

void AboutBox(GtkWidget *widg, gpointer p) {
	GtkWidget *aboutwin;
	GtkWidget *vbox, *eventbox;
	GtkWidget *pixmap;
	GtkWidget *label;
	GdkPixmap *icone;
	GdkBitmap *mask;

	aboutwin = gtk_window_new( GTK_WINDOW_TOPLEVEL );
	gtk_window_set_title(GTK_WINDOW(aboutwin), "A propos ...");
	gtk_window_position( GTK_WINDOW(aboutwin), GTK_WIN_POS_CENTER );
	gtk_signal_connect (GTK_OBJECT (aboutwin), "delete_event",
                               GTK_SIGNAL_FUNC (close_info), aboutwin);
	gtk_widget_realize(aboutwin);

	eventbox=gtk_event_box_new();
	gtk_signal_connect (GTK_OBJECT (eventbox), "button_press_event",
                               GTK_SIGNAL_FUNC (close_info), aboutwin);
	gtk_container_border_width(GTK_CONTAINER(eventbox), 30);
	gtk_container_add(GTK_CONTAINER(aboutwin), eventbox);
	gtk_widget_show(eventbox);

	vbox=gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(eventbox), vbox);
	gtk_widget_show(vbox);
	
	icone=gdk_pixmap_create_from_xpm_d(aboutwin->window, &mask,
                                               &aboutwin->style->bg[GTK_STATE_NORMAL],
                                               FileManager);
	pixmap=gtk_pixmap_new(icone, mask);
	gtk_box_pack_start(GTK_BOX(vbox), pixmap, FALSE, TRUE, 4);
	gtk_widget_show(pixmap);
	label=gtk_label_new("Gtk Explorer - ver. alpha\n"
			    "Emmanuel Varagnat\n\n"
			    "emmanuel.varagnat@altavista.net\n"
			    "evaragna@etu.dir.univ-rouen.fr");
	gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, TRUE, 4);
	gtk_widget_show(label);

	gtk_grab_add(aboutwin);
	gtk_widget_show(aboutwin);
}
