/* Copyright (C) Emmanuel Varagnat 1998

   Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
   le modifier conformment aux dispositions de la Licence Publique Gnrale
   GNU, telle que publie par la Free Software Foundation ; version 2 de la
   licence, ou encore ( votre choix) toute version ultrieure.

   Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE
   GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION ou
   D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail, voir la Licence
   Publique Gnrale GNU .

   Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en
   mme temps que ce programme ; si ce n'est pas le cas, crivez  la Free
   Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.

  ==========================================================================

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

  ==========================================================================

   Ecrit par Emmanuel Varagnat (emmanuel.varagnat@altavista.net)  */

#include <unistd.h>
#include <stdio.h>
#include <malloc.h>
#include <sys/stat.h>
#include <string.h>
#include <errno.h>
#include <glib.h>

#include <gtk/gtk.h>
#include <gdk/gdk.h>
/*#include <gdk/gdkprivate.h>*/
#include <gdk/gdkkeysyms.h>

#include "types.h"
#include "arbo.h"
#include "config.h"
#include "dialogs.h"
#include "files.h"
#include "log.h"
#include "menu.h"
#include "mountmenu.h"
#include "popups.h"

#include "../images/FileManager.xpm"
#include "../images/fichier.xpm"
#include "../images/dir_norm.xpm"
#include "../images/dir_link_vert.xpm"
#include "../images/dir_ro_orange.xpm"
#include "../images/link.xpm"
#include "../images/recycle.xpm"
#include "../images/no_recycle.xpm"
#include "../images/icon_updir.xpm"
#include "../images/icon_details.xpm"
#include "../images/icon_del.xpm"
#include "../images/icon_info.xpm"
#include "../images/icon_show_log.xpm"
#include "../icons/xpm_exe.xpm"
#include "../icons/xpm_o.xpm"
#include "../icons/xpm_a.xpm"
#include "../icons/xpm_make.xpm"

#define XPM_ICONE FileManager
#define IS_DIR dir_norm
#define IS_DIR_LNK dir_link_vert
#define IS_RO  dir_ro_orange_xpm
#define IS_FILE fichier
#define IS_EXE xpm_exe
#define IS_FILE_LNK link_xpm
#define POUBELLE1 recycle
#define POUBELLE2 no_recycle_xpm

#define LG_PATH 255	/* Longueur max d'un nom de fichier (chemin + nom) */
#define LG_BUFF 255	/* Longueur max d'une ligne */

extern char *HOMEpath;

static int poub_active=1;

GtkWidget *mainwin;
GtkWidget *scroll_arbo;
GtkWidget *pano, *scroll_clist;
GtkWidget *chdir_edit, *fname_edit;
static GtkWidget *statusbar1, *statusbar2, *statusbar3;

GtkTooltips *tips;
GtkCTreeNode *HOMEnode;
GtkAccelGroup *accel_group;

static GdkPixmap *pix_nopoub;
static GdkBitmap *msk_nopoub;
GdkPixmap *pix_make, *pix_o, *pix_a;
GdkBitmap *msk_make, *msk_o, *msk_a;
GdkPixmap *pix_dir, *pix_dlnk, *pix_rdo, *pix_file, *pix_exe, *pix_flnk, *pix_poub;
GdkBitmap *msk_dir, *msk_dlnk, *msk_rdo, *msk_file, *msk_exe, *msk_flnk, *msk_poub;

int flag_cmd=0;	/* indique la commande en cours (pour la copie et 
		le deplacement en attendant que le drag & drop marchent */

static gint key_handler(GtkWidget*, GdkEvent*);
static void chdir_enter_callback(GtkEntry*, gpointer*);
static void fname_enter_callback(GtkEntry*, gpointer*);
static void Init_Pixmaps();
static void create_icon_bar(GtkBox*);
static void trash_indic_state(GtkWidget*, GdkEventButton*, GtkPixmap*);

/********************************************************************/
/********************************************************************/
/********************************************************************/
/********************************************************************/

int main(int argc, char *argv[]) {
	GtkWidget *vbox, *statusbox, *iconbar;
	GtkWidget *vbox_pano_g, *vbox_pano_d;
	GtkWidget *trash, *eventbox;
/*	GtkWidget *saisie;*/
	GtkWidget *linesep;
	GtkWidget *log;

	GdkPixmap *icone;
	GdkBitmap *mask;
	GdkColormap *colormap;
	GdkColor color = {0, 0xff00, 0xff00, 0xde00 };

        gtk_init (&argc, &argv);

	if (!g_thread_supported())
		g_thread_init (NULL);

	/* cr la fenetre de log avant tout le reste, pour l'affichage des erreurs internes */
	log = create_log_text();

	/* fenetre principale */
	mainwin = gtk_window_new( GTK_WINDOW_TOPLEVEL );
	gtk_window_set_title(GTK_WINDOW(mainwin), "Explorer");
	gtk_widget_set_usize(mainwin, 640, 480);
	gtk_signal_connect (GTK_OBJECT (mainwin), "delete_event",
                        GTK_SIGNAL_FUNC (gtk_main_quit), NULL);
	gtk_signal_connect(GTK_OBJECT(mainwin), "event",
			GTK_SIGNAL_FUNC(key_handler), NULL);
	gtk_widget_realize(mainwin);

	/* Touches de raccourcis */
	accel_group = gtk_accel_group_new ();
	gtk_accel_group_attach (accel_group, GTK_OBJECT (mainwin));

	/* Divers */
	Init_Pixmaps();
	load_config(&opt);
	CreatePopup4File();
	CreatePopup4Dir();

	/* Initialise le tooltips (couleur post-it) pour l'arborescence */
	colormap = gdk_window_get_colormap (mainwin->window);
	gdk_color_alloc (colormap, &color);
	tips=gtk_tooltips_new();
	gtk_tooltips_set_delay(tips, 1000);
	gtk_tooltips_set_colors(tips, &color, &mainwin->style->fg[GTK_STATE_NORMAL]);

	/* Ajoute l'icone */
	icone=gdk_pixmap_create_from_xpm_d(mainwin->window, &mask,
                                               &mainwin->style->bg[GTK_STATE_NORMAL],
                                               XPM_ICONE);
	gdk_window_set_icon (mainwin->window, NULL, icone, mask);
	gdk_window_set_icon_name (mainwin->window, "Explorer");

	
	/* cree la boite verticale destinee a recevoir tout le reste */
	vbox=gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(mainwin), vbox);
	gtk_widget_show(vbox);
	
	/* Cree le menu */
	CreateMainMenu();
	gtk_box_pack_start(GTK_BOX(vbox), mainmenu, FALSE, TRUE, 0);
	gtk_widget_show(mainmenu);
	
	/* cree la barre d'icone */
	iconbar=gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), iconbar, FALSE, FALSE, 2);
	gtk_widget_show(iconbar);
	create_icon_bar(GTK_BOX(iconbar));

	/* cree le panneau pour la separation */
	pano=gtk_hpaned_new();
	gtk_paned_gutter_size(GTK_PANED(pano), 15);
	gtk_box_pack_start(GTK_BOX(vbox), pano, TRUE, TRUE, 0);
	gtk_widget_show(pano);

	/* cree la partie gauche de la separation avec la saisie pour 'chdir' */
	vbox_pano_g=gtk_vbox_new(FALSE, 0);
	gtk_paned_add1(GTK_PANED(pano), vbox_pano_g);
	gtk_widget_show(vbox_pano_g);

	chdir_edit = gtk_entry_new();
	gtk_signal_connect(GTK_OBJECT(chdir_edit), "activate",
				GTK_SIGNAL_FUNC(chdir_enter_callback), NULL);
	gtk_box_pack_start(GTK_BOX(vbox_pano_g), chdir_edit, FALSE, FALSE, 3);
	gtk_widget_show(chdir_edit);

	/* cree la fenetre scrollable pour l'arborescence */
        scroll_arbo = gtk_scrolled_window_new (NULL, NULL);
        gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scroll_arbo),
                                        GTK_POLICY_AUTOMATIC,
                                        GTK_POLICY_ALWAYS);
        gtk_widget_set_usize (scroll_arbo, 200, 0);
	gtk_box_pack_start(GTK_BOX(vbox_pano_g), scroll_arbo, TRUE, TRUE, 0);
        gtk_widget_show (scroll_arbo);

	/* cree la partie droite de la separation avec la saisie pour 'chdir' */
	vbox_pano_d=gtk_vbox_new(FALSE, 0);
	gtk_paned_add2(GTK_PANED(pano), vbox_pano_d);
	gtk_widget_show(vbox_pano_d);

	fname_edit = gtk_entry_new();
	gtk_signal_connect(GTK_OBJECT(fname_edit), "activate",
				GTK_SIGNAL_FUNC(fname_enter_callback), NULL);
	gtk_box_pack_start(GTK_BOX(vbox_pano_d), fname_edit, FALSE, FALSE, 3);
	gtk_widget_show(fname_edit);

	/* puis la liste de fichier */
	scroll_clist = gtk_scrolled_window_new (NULL, NULL);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scroll_clist),
					GTK_POLICY_AUTOMATIC,
					GTK_POLICY_AUTOMATIC);
	gtk_container_add(GTK_CONTAINER (scroll_clist), InitFileList());
	gtk_widget_show(scroll_clist);
	gtk_box_pack_start(GTK_BOX(vbox_pano_d), scroll_clist, TRUE, TRUE, 0);
	gtk_widget_show(filelst);

	/* Initialise l'arborescence */
	HOMEnode=InitArbo(scroll_arbo);

	/* Zone de texte pour le log */
        gtk_box_pack_start(GTK_BOX(vbox), log, FALSE, FALSE, 0);
	log_text_show(0);

	/* Ligne de separation */
	linesep = gtk_hseparator_new ();
	gtk_box_pack_start (GTK_BOX (vbox), linesep, FALSE, TRUE, 0);
	gtk_widget_show (linesep);

	/* Boite pour les 2 barre d'etats */
	statusbox=gtk_hbox_new(FALSE, 5);
	gtk_box_pack_start(GTK_BOX(vbox), statusbox, FALSE, TRUE, 0);
	gtk_container_border_width(GTK_CONTAINER(statusbox), 3);
	gtk_widget_show(statusbox);
	
	/* Ajoute les barres d'etats et la zone de saisie */
	statusbar1=gtk_statusbar_new();
	gtk_box_pack_start(GTK_BOX(statusbox), statusbar1, FALSE, TRUE, 0);
	gtk_widget_show(statusbar1);
	
	gtk_widget_realize(statusbar1);
	
	gtk_statusbar_push(GTK_STATUSBAR(statusbar1), 1, "##########");
	statusbar2=gtk_statusbar_new();
	gtk_box_pack_start(GTK_BOX(statusbox), statusbar2, TRUE, TRUE, 0);
	gtk_widget_show(statusbar2);
	statusbar3=gtk_statusbar_new();
	gtk_box_pack_start(GTK_BOX(statusbox), statusbar3, TRUE, TRUE, 0);
	gtk_widget_show(statusbar3);

	trash=gtk_pixmap_new(pix_poub, msk_poub);
	eventbox=gtk_event_box_new();
	gtk_signal_connect (GTK_OBJECT (eventbox), "button_press_event",
                               GTK_SIGNAL_FUNC (trash_indic_state), trash);
	gtk_box_pack_start(GTK_BOX(statusbox), eventbox, FALSE, TRUE, 0);
	gtk_tooltips_set_tip (tips, eventbox, "Active/Desactive", NULL);
	gtk_widget_show(eventbox);
	gtk_container_add(GTK_CONTAINER(eventbox), trash);
	gtk_widget_show(trash);	

	/* se place dans $HOME */
	arbo_change_dir(HOMEpath);

	gtk_widget_show(mainwin);
/*	XBell(((GdkWindowPrivate*)mainwin->window)->xdisplay, 0);*/
	gtk_main();
	return 0;
}

/********************************************************************/
/********************************************************************/

static void Init_Pixmaps() {
	GtkStyle *style=gtk_widget_get_style(mainwin);
	
	pix_dir = gdk_pixmap_create_from_xpm_d(mainwin->window, &msk_dir,
						&style->bg[GTK_STATE_NORMAL],
						IS_DIR);
	pix_dlnk = gdk_pixmap_create_from_xpm_d(mainwin->window, &msk_dlnk,
						&style->bg[GTK_STATE_NORMAL],
						IS_DIR_LNK);
	pix_rdo = gdk_pixmap_create_from_xpm_d(mainwin->window, &msk_rdo,
						&style->bg[GTK_STATE_NORMAL],
						IS_RO);
	pix_file = gdk_pixmap_create_from_xpm_d(mainwin->window, &msk_file,
						&style->bg[GTK_STATE_NORMAL],
						IS_FILE);
	pix_exe = gdk_pixmap_create_from_xpm_d(mainwin->window, &msk_exe,
						&style->bg[GTK_STATE_NORMAL],
						IS_EXE);
	pix_flnk = gdk_pixmap_create_from_xpm_d(mainwin->window, &msk_flnk,
						&style->bg[GTK_STATE_NORMAL],
						IS_FILE_LNK);
	pix_poub = gdk_pixmap_create_from_xpm_d(mainwin->window, &msk_poub,
						&style->bg[GTK_STATE_NORMAL],
						POUBELLE1);
	pix_nopoub = gdk_pixmap_create_from_xpm_d(mainwin->window, &msk_nopoub,
						&style->bg[GTK_STATE_NORMAL],
						POUBELLE2);

	pix_o = gdk_pixmap_create_from_xpm_d(mainwin->window, &msk_o,
						&style->bg[GTK_STATE_NORMAL],
						xpm_o_xpm);
	pix_a = gdk_pixmap_create_from_xpm_d(mainwin->window, &msk_a,
						&style->bg[GTK_STATE_NORMAL],
						xpm_a_xpm);
	pix_make = gdk_pixmap_create_from_xpm_d(mainwin->window, &msk_make,
						&style->bg[GTK_STATE_NORMAL],
						xpm_make_xpm);
}


/********************************************************************/
/********************************************************************/

static void toggle_log_text (GtkWidget *widget, gpointer data) {
    if (GTK_TOGGLE_BUTTON (widget)->active)
	 log_text_show(1);
    else
	 log_text_show(0);
}

static void create_icon_bar(GtkBox *box) {
	GtkWidget *button, *pix;
	GdkPixmap *xpm;
	GdkBitmap *msk;
	
	gtk_box_pack_start (box, create_mount_menu(), FALSE, FALSE, 10);

	/* bouton pour remonter d'un rpertoire */
	button=gtk_button_new();
	xpm = gdk_pixmap_create_from_xpm_d(mainwin->window, &msk,
						&mainwin->style->bg[GTK_STATE_NORMAL],
						icon_updir_xpm);
	pix=gtk_pixmap_new(xpm, msk);
	gtk_container_add(GTK_CONTAINER(button), pix);
	gtk_box_pack_start (box, button, FALSE, FALSE, 0);
	gtk_widget_show(pix);
	gtk_widget_show(button);

	/* bouton de suppression de fichier */
	button=gtk_button_new();
	gtk_tooltips_set_tip (tips, button, "Supprime", NULL);
	xpm = gdk_pixmap_create_from_xpm_d(mainwin->window, &msk,
						&mainwin->style->bg[GTK_STATE_NORMAL],
						icon_del_xpm);
	pix=gtk_pixmap_new(xpm, msk);
	gtk_container_add(GTK_CONTAINER(button), pix);
	gtk_box_pack_start (box, button, FALSE, FALSE, 0);
	gtk_widget_show(pix);
	gtk_widget_show(button);

	/* bouton des options */
	button=gtk_button_new();
	xpm = gdk_pixmap_create_from_xpm_d(mainwin->window, &msk,
						&mainwin->style->bg[GTK_STATE_NORMAL],
						icon_details_xpm);
	pix=gtk_pixmap_new(xpm, msk);
	gtk_container_add(GTK_CONTAINER(button), pix);
	gtk_box_pack_start (box, button, FALSE, FALSE, 0);
	gtk_widget_show(pix);
	gtk_widget_show(button);

	/* bouton d'affichage du log */
	button=gtk_toggle_button_new();
	gtk_tooltips_set_tip (tips, button, "Zone de log", NULL);
	xpm = gdk_pixmap_create_from_xpm_d(mainwin->window, &msk,
						&mainwin->style->bg[GTK_STATE_NORMAL],
						icon_show_log_xpm);
	pix=gtk_pixmap_new(xpm, msk);
	gtk_container_add(GTK_CONTAINER(button), pix);
	gtk_box_pack_start (box, button, FALSE, FALSE, 0);
	gtk_signal_connect (GTK_OBJECT (button), "toggled",
                               GTK_SIGNAL_FUNC (toggle_log_text), NULL);
	gtk_widget_show(pix);
	gtk_widget_show(button);

	/* bouton d'aide */
	button=gtk_button_new();
	gtk_tooltips_set_tip (tips, button, "Aide", NULL);
	xpm = gdk_pixmap_create_from_xpm_d(mainwin->window, &msk,
						&mainwin->style->bg[GTK_STATE_NORMAL],
						icon_info);
	pix=gtk_pixmap_new(xpm, msk);
	gtk_container_add(GTK_CONTAINER(button), pix);
	gtk_box_pack_end (box, button, FALSE, FALSE, 10);
	gtk_widget_show(pix);
	gtk_widget_show(button);
}

/********************************************************************/
/********************************************************************/

static gint key_handler(GtkWidget *widget, GdkEvent *event) {
	GdkEventKey *kevent;
	
	switch(event->type) {
		case GDK_KEY_PRESS:
			kevent = (GdkEventKey*) event;
			if(kevent->keyval==GDK_Escape && (flag_cmd==1 || flag_cmd==2)) {
				GdkCursor *hand;
				
				flag_cmd=0;
				gtk_clist_set_selection_mode(GTK_CLIST(arbo), GTK_SELECTION_SINGLE);
				gtk_grab_remove(scroll_arbo);
				hand=gdk_cursor_new(GDK_LEFT_PTR);
				gdk_window_set_cursor (mainwin->window, hand);
				return TRUE;
			}
/*			if(kevent->keyval==GDK_Delete)
				write(1, "Suppr", 5);*/
			break;
		case GDK_KEY_RELEASE:
			break;
		default:
			return FALSE;
	}
	return FALSE;
}

static void chdir_enter_callback(GtkEntry *w, gpointer *p) {
     struct stat st;
     char *txt;
     int n;

     txt=gtk_entry_get_text(w);
     n=strlen(txt);


     if(txt[n-1]=='/')
     	 txt[n-1]='\0';
     
     if(access(txt, X_OK | R_OK)==-1) {
         char msg[100];
	 sprintf(msg, 
	         "Le rpertoire n'est pas accessible et/ou non lisible\n\nErreur:\n%s",
		 strerror(errno));
         msg_dialog("Erreur", msg);
	 gtk_entry_set_text(GTK_ENTRY(w), select_path);
	 return;
     }

     if(stat(txt, &st)==-1) {
         char msg[100];
	 sprintf(msg, 
	         "Ne peut rcuperer les infos sur le rpertoire\n\nErreur:\n%s",
		 strerror(errno));
         msg_dialog("Erreur", msg);
	 gtk_entry_set_text(GTK_ENTRY(w), select_path);
     }
     else if(!S_ISDIR(st.st_mode)) {
	      msg_dialog("Erreur", "Le chemin n'est pas un rpertoire");
	      gtk_entry_set_text(GTK_ENTRY(w), select_path);
	  }
	  else
  	      arbo_change_dir(txt);
}

static void fname_enter_callback(GtkEntry *w, gpointer *p) {
	char *txt;

	txt=gtk_entry_get_text(w);
	g_print("%s: %d\n", txt, access(txt, X_OK));
}

static void trash_indic_state(GtkWidget *widget, GdkEventButton *event, GtkPixmap *pix) {
	if (event->type == GDK_2BUTTON_PRESS) {
		poub_active=!poub_active;
		if(poub_active)
			gtk_pixmap_set(pix, pix_poub,GTK_STATE_NORMAL);
		else
			gtk_pixmap_set(pix, pix_nopoub,GTK_STATE_NORMAL);
	}
}

/********************************************************************/
/********************************************************************/

gchar *my_getcwd() {
	gchar *cwd=NULL, *ret;
	int lg=255;
	
	cwd = (gchar*)malloc(lg*sizeof(gchar));

	errno = 0;
	while ((ret = getcwd (cwd, lg))==NULL && errno==ERANGE) {
		lg += 20;
		cwd = (gchar*)realloc (cwd, lg*sizeof(gchar));
		errno = 0;
	}

	if (ret == NULL) {
		int save_errno = errno;
		free (cwd);
		errno = save_errno;
		return NULL;
	}
	return cwd;
}


/********************************************************************/
/* Cree une boite avec un pixmap (specifie en argument) et un label */
/********************************************************************/
GtkWidget *Pixmaped_label_item(gchar *label_text, GdkPixmap *pixmap, GdkBitmap *mask) {
	GtkWidget *hbox;
	GtkWidget *label;
	GtkWidget *pixmapwid;

	hbox = gtk_hbox_new (FALSE, 0);

	pixmapwid = gtk_pixmap_new (pixmap, mask);

	label = gtk_label_new (label_text);

	gtk_box_pack_start (GTK_BOX (hbox), pixmapwid, FALSE, FALSE, 0);
	gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 2);

	gtk_widget_show(pixmapwid);
	gtk_widget_show(label);
	return (hbox);
}

GtkWidget *Pixmaped_label_item_from_data(gchar *label_text, gchar **pix) {
	GtkWidget *hbox;
	GtkWidget *label;
	GtkWidget *pixmapwid;
	GdkPixmap *pixmap;
	GdkBitmap *mask;
	GtkStyle *style;

	hbox = gtk_hbox_new (FALSE, 0);

	style = gtk_widget_get_style(mainwin);
	pixmap = gdk_pixmap_create_from_xpm_d(mainwin->window, &mask,
						&style->bg[GTK_STATE_NORMAL],
						pix);
	pixmapwid = gtk_pixmap_new (pixmap, mask);

	label = gtk_label_new (label_text);

	gtk_box_pack_start (GTK_BOX (hbox), pixmapwid, FALSE, FALSE, 0);
	gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 6);

	gtk_widget_show(pixmapwid);
	gtk_widget_show(label);
	return (hbox);
}


/********************************************************************/
/********************************************************************/

void statusbar_display(int n, char *msg) {
      GtkWidget *st;

      switch(n) {
	 case 1:  st=statusbar1;
	   	  break;
	 case 2:  st=statusbar2;
	   	  break;
	 case 3:  st=statusbar3;
	   	  break;
	 default: return;
      }

      gtk_statusbar_pop(GTK_STATUSBAR(st), 1);
      gtk_statusbar_push(GTK_STATUSBAR(st), 1, msg);
}
