/* Copyright (C) Emmanuel Varagnat 1998

   Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
   le modifier conformment aux dispositions de la Licence Publique Gnrale
   GNU, telle que publie par la Free Software Foundation ; version 2 de la
   licence, ou encore ( votre choix) toute version ultrieure.

   Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE
   GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION ou
   D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail, voir la Licence
   Publique Gnrale GNU .

   Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en
   mme temps que ce programme ; si ce n'est pas le cas, crivez  la Free
   Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.

  ==========================================================================

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

  ==========================================================================

   Ecrit par Emmanuel Varagnat (emmanuel.varagnat@altavista.net)  */

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/vfs.h>

#include "arbo.h"
#include "dialogs.h"

/*#include <linux/affs_fs.h>*/
#include <linux/ext_fs.h>
#include <linux/ext2_fs.h>
#include <linux/hpfs_fs.h>
#include <linux/iso_fs.h>
#include <linux/minix_fs.h>
/*#include <linux/msdos_fs.h>
#include <linux/ncp_fs.h>*/
#include <linux/nfs_fs.h>
/*#include <linux/proc_fs.h>*/
#include <linux/smb_fs.h>
/*#include <linux/sysv_fs.h>
#include <linux/ufs_fs.h>
#include <linux/xia_fs.h>
*/

static gint keyhandler(GtkWidget *widget, GdkEventKey *event, GtkWidget *win) {
	if(event->keyval==GDK_Escape) {
		gtk_grab_remove(win);
		gtk_widget_destroy(win);
		return TRUE;
	}
	return FALSE;
}

/*******************************************************************/
/*******************************************************************/

void ShowFSInfo(char *name) {
	GtkWidget *win;
	GtkWidget *hbox, *label;
	struct statfs fsinfo;
	char txt[400], aux[50];
	
	strcpy(txt, select_path);
	strcat(txt, "/");
	strcat(txt, name);
	if(statfs(txt, &fsinfo)) {
		msg_dialog("Erreur", strerror(errno));
		return;
	}

	win = gtk_window_new( GTK_WINDOW_TOPLEVEL );
	gtk_window_set_title(GTK_WINDOW(win), "File System Info");
	gtk_signal_connect (GTK_OBJECT (win), "key_press_event",
                               GTK_SIGNAL_FUNC (keyhandler), win);
	gtk_signal_connect (GTK_OBJECT (win), "delete_event",
                               GTK_SIGNAL_FUNC (gtk_widget_destroy), NULL);
	gtk_container_border_width(GTK_CONTAINER(win), 10);
	gtk_widget_realize(win);
	gtk_grab_add(win);
	
	hbox=gtk_hbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(win), hbox);
	gtk_widget_show(hbox);

        switch (fsinfo.f_type) {
/*             case AFFS_SUPER_MAGIC :
                  strcpy (txt, "AFFS");
                  break;
             case EXT2_SUPER_MAGIC :
             case EXT2_OLD_SUPER_MAGIC :
                  strcpy (txt, "EXT 2");
                  break;
             case EXT_SUPER_MAGIC :
                  strcpy (txt, "EXT");
                  break;
             case HPFS_SUPER_MAGIC :
                  strcpy (txt, "HP");
                  break;
             case ISOFS_SUPER_MAGIC :
                  strcpy (txt, "ISO");
                  break;
             case MINIX_SUPER_MAGIC :
             case MINIX_SUPER_MAGIC2 :
             case MINIX2_SUPER_MAGIC :
             case MINIX2_SUPER_MAGIC2 :
                  strcpy (txt, "MINIX");
                  break;
             case MSDOS_SUPER_MAGIC :
                  strcpy (txt, "MS-DOS");
                  break;
             case NCP_SUPER_MAGIC :
                  strcpy (txt, "NCP");
                  break;
             case NFS_SUPER_MAGIC :
                  strcpy (txt, "NFS");
                  break;
             case PROC_SUPER_MAGIC :
                  strcpy (txt, "PROC");
                  break;
             case SMB_SUPER_MAGIC :
                  strcpy (txt, "SMB");
                  break;
             case XENIX_SUPER_MAGIC :
             case SYSV4_SUPER_MAGIC :
             case SYSV2_SUPER_MAGIC :
             case COH_SUPER_MAGIC :
                  strcpy (txt, "SysV");
                  break;
             case UFS_MAGIC :
                  strcpy (txt, "UFS");
                  break;
             case _XIAFS_SUPER_MAGIC :
                  strcpy (txt, "XIA");
                  break;*/
             default :
                  strcpy (txt, "???");
        }

	sprintf(aux, "                Systme de fichier: %s", aux);
	strcpy(txt, aux);
/*	sprintf(aux, "Systme de fichier:   %x\n", fsinfo.f_type);
	strcpy(txt, aux);*/
/*	sprintf(aux, "Nombre total de blocs:   %d\n", fsinfo.f_blocks);
	strcat(txt, aux);	
	sprintf(aux, "Taille optimal de blocs:   %d\n", fsinfo.f_bsize);
	strcat(txt, aux);	
	sprintf(aux, "Blocs libres:   %d\n", fsinfo.f_bfree);
	strcat(txt, aux);	
	sprintf(aux, "Blocs libres pour utilisateurs:    %d\n", fsinfo.f_bavail);
	strcat(txt, aux);	
	sprintf(aux, "Nombre d'i-noeuds:   %d\n", fsinfo.f_files);
	strcat(txt, aux);	
	sprintf(aux, "Nombre d'i-noeuds libres:   %d\n", fsinfo.f_ffree);
	strcat(txt, aux);	
	sprintf(aux, "Longueur maxi des noms de fichiers:   %d", fsinfo.f_namelen);
	strcat(txt, aux);	
*/
	label=gtk_label_new(txt);
	gtk_label_set_justify (GTK_LABEL(label), GTK_JUSTIFY_LEFT);
	gtk_box_pack_start(GTK_BOX(hbox), label, FALSE, TRUE, 0);
	gtk_widget_show(label);

	gtk_widget_show(win);	
}


