/* Copyright (C) Emmanuel Varagnat 1998

   Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
   le modifier conformment aux dispositions de la Licence Publique Gnrale
   GNU, telle que publie par la Free Software Foundation ; version 2 de la
   licence, ou encore ( votre choix) toute version ultrieure.

   Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE
   GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION ou
   D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail, voir la Licence
   Publique Gnrale GNU .

   Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en
   mme temps que ce programme ; si ce n'est pas le cas, crivez  la Free
   Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.

  ==========================================================================

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

  ==========================================================================

   Ecrit par Emmanuel Varagnat (emmanuel.varagnat@altavista.net)  */

#include <gtk/gtk.h>
#include <unistd.h>
#include <pthread.h>
#include "log.h"

int pipe1[2], pipe2[2];
GtkWidget *log_text;

static GdkColor rouge;
static GtkWidget *table;

static void log_text_normal_output() {
	char buff[100];
	int n;
	
	while((n=read(pipe1[0], buff, 100))) {
	    GDK_THREADS_ENTER ();
	    gtk_text_insert(GTK_TEXT(log_text), NULL, NULL, NULL, buff, n);
	    GDK_THREADS_LEAVE ();
	}
}

static void log_text_error_output() {
	char buff[100];
	int n;
	
	while((n=read(pipe2[0], buff, 100))) {
	    GDK_THREADS_ENTER ();
	    gtk_text_insert(GTK_TEXT(log_text), NULL, &rouge, NULL, buff, n);
	    GDK_THREADS_LEAVE ();
	}
}

GtkWidget *create_log_text() {
	GtkWidget *vscroll;
        GdkColormap *cmap;
	pthread_t th_err, th_norm;

        table = gtk_table_new (2, 2, FALSE);
        gtk_table_set_row_spacing (GTK_TABLE (table), 0, 2);
        gtk_table_set_col_spacing (GTK_TABLE (table), 0, 2);
        gtk_widget_show (table);

        log_text = gtk_text_new (NULL, NULL);
        gtk_text_set_editable(GTK_TEXT (log_text), FALSE);
	gtk_text_set_line_wrap(GTK_TEXT (log_text), TRUE);
	gtk_table_attach (GTK_TABLE (table), log_text, 0, 1, 0, 1,
                          GTK_EXPAND | GTK_SHRINK | GTK_FILL,
                          GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
        gtk_widget_show (log_text);

        vscroll = gtk_vscrollbar_new (GTK_TEXT (log_text)->vadj);
        gtk_table_attach (GTK_TABLE (table), vscroll, 1, 2, 0, 1,
                          GTK_FILL, GTK_EXPAND | GTK_SHRINK | GTK_FILL, 0, 0);
        gtk_widget_show (vscroll);

        /* Get the system colour map and allocate the colour red */
        cmap = gdk_colormap_get_system();
        rouge.red = 0xffff;
        rouge.green = 0;
        rouge.blue = 0;
        if (!gdk_color_alloc(cmap, &rouge)) {
          g_error("couldn't allocate colour");
        }

	pipe1[1]=-1;   /* pour savoir qu'il y a eu erreur lorsqu'on */
	pipe2[1]=-1;   /* les utilisera (ex: mount/umount)	    */
	if( pipe(pipe1) || pipe(pipe2) )
	       gtk_text_insert(GTK_TEXT(log_text), NULL, &rouge, NULL, 
	       			"LOG INDISPONIBLE, ne peut crer de tubes", 40);
	else {	     
	   if(pthread_create(&th_norm, NULL, (void *)log_text_normal_output, NULL)
	      || pthread_create(&th_err , NULL, (void *)log_text_error_output , NULL))
	      	  gtk_text_insert(GTK_TEXT(log_text), NULL, &rouge, NULL, 
	       			"LOG INDISPONIBLE, ne peut crer de threads", 42);
	}
		
	return table;
}

void log_text_show(int bool) {
	if(bool)
	    gtk_widget_show(table);
	else
	    gtk_widget_hide(table);
}

void log_text_add(enum text_type t, char *txt) {
	GdkColor *coul = NULL;

	switch(t) {
	    case ERREUR:
	    	coul=&rouge;
	    default:
	    	break;
	}

	gtk_text_insert(GTK_TEXT(log_text), NULL, coul, NULL, txt, strlen(txt));
}
