/* Copyright (C) Emmanuel Varagnat 1998

   Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
   le modifier conformment aux dispositions de la Licence Publique Gnrale
   GNU, telle que publie par la Free Software Foundation ; version 2 de la
   licence, ou encore ( votre choix) toute version ultrieure.

   Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE
   GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION ou
   D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail, voir la Licence
   Publique Gnrale GNU .

   Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en
   mme temps que ce programme ; si ce n'est pas le cas, crivez  la Free
   Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.

  ==========================================================================

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

  ==========================================================================

   Ecrit par Emmanuel Varagnat (emmanuel.varagnat@altavista.net)  */

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>

#include "types.h"
#include "about.h"
#include "arbo.h"
#include "config.h"
#include "explore.h"
#include "files.h"
#include "popups.h"
#include "preferences.h"

#include "../images/Drap Anglais.xpm"
#include "../images/Drap Francais.xpm"

char *menustr[][NB_LANG]={
			{"Fichier",	"File"		},	/* 0 */
			{"Options",	"Options"	},
			{"Aide",	"Help"		},

			{"Nouveau",	 "New"		},	/* 3 */
			{"Copier", 	 "Copy"	},
			{"Dplacer",	 "Move"	},
			{"Supprimer",	 "Remove"	},
			{"Informations","Informations"},
			{"Changer de rpertoire", "Change directory"},
			{"Quitter",	"Quit"		},

			{"Montrer fichiers cachs", "Show hidden files"}, /* 10 */
			{"Montrer rpertoires cachs", "Show hidden directories"},
			{"Prfrences", "Preferences"	},

			{"A propos...",	"About..."	}	/* 13 */

		 };

void CreateMainMenu();

static void ChangeLangue(GtkWidget*, gint);
static void Show_HiddenFile(GtkWidget*);
static void Show_HiddenDir(GtkWidget*);
static void menu_chdir();
static GtkWidget *SubmenuFichier();
static GtkWidget *SubmenuOption();
static GtkWidget *SubmenuAide();
static void ChangeMainMenu();

GtkWidget *mainmenu;

static void ChangeLangue(GtkWidget *item, gint lg) {
	/* Menu principal */
	opt.lang=lg;
	ChangeMainMenu();

	/* Menu popup */
	gtk_widget_destroy(pop_file);
	CreatePopup4File();
}

static void Show_HiddenFile(GtkWidget *item) {
	if(GTK_CHECK_MENU_ITEM(item)->active!=TRUE) opt.sh_hfil=0;
	else					opt.sh_hfil=1;

/*	gtk_clist_clear (GTK_CLIST (filelst)); */
	Refresh_file_list(select_path);
}
static void Show_HiddenDir(GtkWidget *item) {
	if(GTK_CHECK_MENU_ITEM(item)->active!=TRUE) opt.sh_hdir=0;
	else					opt.sh_hdir=1;

/*	gtk_clist_clear (GTK_CLIST (filelst)); */
	Refresh_file_list(select_path);
}

static void menu_suppr() {
	g_print("Supprimer\n");
}

static void menu_chdir() {
}

static GtkWidget *SubmenuFichier() {
	GtkWidget *item, *menu;

	menu=gtk_menu_new();
	gtk_menu_set_accel_group (GTK_MENU (menu), accel_group);
	
	/* Menu Fichier */
	item=gtk_menu_item_new_with_label(menustr[menu_fichier][opt.lang]);
	gtk_menu_append(GTK_MENU(menu), item);
	gtk_widget_show(item);

	item=gtk_menu_item_new_with_label(menustr[menu_fichier+1][opt.lang]);
	gtk_menu_append(GTK_MENU(menu), item);
	gtk_widget_show(item);

	item=gtk_menu_item_new_with_label(menustr[menu_fichier+2][opt.lang]);
	gtk_menu_append(GTK_MENU(menu), item);
	gtk_widget_show(item);

	item=gtk_menu_item_new_with_label(menustr[menu_fichier+3][opt.lang]);
 	gtk_signal_connect_object(GTK_OBJECT(item), "activate",
		GTK_SIGNAL_FUNC(menu_suppr), (gpointer)NULL);
	gtk_widget_add_accelerator (item, "activate", accel_group,
		GDK_BackSpace, 0, GTK_ACCEL_VISIBLE);
	gtk_menu_append(GTK_MENU(menu), item);
	gtk_widget_show(item);

	item=gtk_menu_item_new();
	gtk_menu_append(GTK_MENU(menu), item);
	gtk_widget_show(item);

	item=gtk_menu_item_new_with_label("Tout slectionner");
	gtk_widget_add_accelerator (item, "activate", accel_group,
		GDK_A, GDK_Control_R, GTK_ACCEL_VISIBLE);
	gtk_menu_append(GTK_MENU(menu), item);
	gtk_widget_show(item);

	item=gtk_menu_item_new_with_label(menustr[menu_fichier+4][opt.lang]);
	gtk_menu_append(GTK_MENU(menu), item);
	gtk_widget_show(item);

	item=gtk_menu_item_new_with_label(menustr[menu_fichier+5][opt.lang]);
	gtk_signal_connect_object(GTK_OBJECT(item), "activate",
		GTK_SIGNAL_FUNC(menu_chdir), (gpointer)NULL);
	gtk_menu_append(GTK_MENU(menu), item);
	gtk_widget_show(item);

	item=gtk_menu_item_new();
	gtk_menu_append(GTK_MENU(menu), item);
	gtk_widget_show(item);

	item=gtk_menu_item_new_with_label(menustr[menu_fichier+6][opt.lang]);
	gtk_menu_append(GTK_MENU(menu), item);
 	gtk_signal_connect_object(GTK_OBJECT(item), "activate",
		GTK_SIGNAL_FUNC(gtk_main_quit), (gpointer)NULL);
	gtk_widget_add_accelerator (item, "activate", accel_group,
		GDK_Q, GDK_Control_R, GTK_ACCEL_VISIBLE);
	gtk_widget_show(item);

	return menu;
}

static GtkWidget *SubmenuOption() {
	GtkWidget *item, *menu;

	menu=gtk_menu_new();
     /* Menu affichage des fichiers caches */
	item=gtk_check_menu_item_new_with_label (menustr[menu_option][opt.lang]);
	if(opt.sh_hfil==1) gtk_check_menu_item_set_state(GTK_CHECK_MENU_ITEM(item), TRUE);
	else gtk_check_menu_item_set_state(GTK_CHECK_MENU_ITEM(item), FALSE);
	gtk_signal_connect_object(GTK_OBJECT(item), "activate",
		GTK_SIGNAL_FUNC(Show_HiddenFile), (gpointer)item);
	gtk_menu_append(GTK_MENU(menu), item);
	gtk_widget_show(item);
     /* Menu affichage des repertoires caches */
	item=gtk_check_menu_item_new_with_label (menustr[menu_option+1][opt.lang]);
	if(opt.sh_hdir==1) gtk_check_menu_item_set_state(GTK_CHECK_MENU_ITEM(item), TRUE);
	else gtk_check_menu_item_set_state(GTK_CHECK_MENU_ITEM(item), FALSE);
	gtk_signal_connect_object(GTK_OBJECT(item), "activate",
		GTK_SIGNAL_FUNC(Show_HiddenDir), (gpointer)item);
	gtk_menu_append(GTK_MENU(menu), item);
	gtk_widget_show(item);
	item=gtk_menu_item_new();
	gtk_menu_append(GTK_MENU(menu), item);
	gtk_widget_show(item);
     /* Menu preferences */
	item=gtk_menu_item_new_with_label(menustr[menu_option+2][opt.lang]);
	gtk_signal_connect_object(GTK_OBJECT(item), "activate",
		GTK_SIGNAL_FUNC(Pref_Dialog), NULL);
	gtk_menu_append(GTK_MENU(menu), item);
	gtk_widget_show(item);
	
	return menu;
}

static GtkWidget *SubmenuAide() {
	GtkWidget *item, *menu, *flag;

	menu=gtk_menu_new();

	item=gtk_menu_item_new();
	flag=Pixmaped_label_item_from_data("Francais", Drap_Francais);
	gtk_widget_show(flag);
	gtk_container_add(GTK_CONTAINER(item), flag);
	gtk_menu_append(GTK_MENU(menu), item);
	gtk_signal_connect(GTK_OBJECT(item), "activate",
		GTK_SIGNAL_FUNC(ChangeLangue), (gpointer)0);
	gtk_widget_show(item);
	item=gtk_menu_item_new();
	flag=Pixmaped_label_item_from_data("English", Drap_Anglais);
	gtk_widget_show(flag);
	gtk_container_add(GTK_CONTAINER(item), flag);
	gtk_signal_connect(GTK_OBJECT(item), "activate",
		GTK_SIGNAL_FUNC(ChangeLangue), (gpointer)1);
	gtk_menu_append(GTK_MENU(menu), item);
	gtk_widget_show(item);
	item=gtk_menu_item_new();
	gtk_menu_append(GTK_MENU(menu), item);
	gtk_widget_show(item);

	/* A propos ... */
	item=gtk_menu_item_new_with_label(menustr[menu_aide][opt.lang]);
	gtk_signal_connect_object(GTK_OBJECT(item), "activate",
		GTK_SIGNAL_FUNC(AboutBox), (gpointer)NULL);
	gtk_widget_add_accelerator (item, "activate", accel_group,
		GDK_F1, GDK_Control_R, GTK_ACCEL_VISIBLE);
	gtk_menu_append(GTK_MENU(menu), item);
	gtk_widget_show(item);

	return menu;
}

void CreateMainMenu() {
	GtkWidget *item;
	
	mainmenu=gtk_menu_bar_new();
	
	item=gtk_menu_item_new_with_label(menustr[barre_menu][opt.lang]);
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(item), SubmenuFichier());
	gtk_menu_bar_append(GTK_MENU_BAR(mainmenu), item);
	gtk_widget_show(item);
	
	item=gtk_menu_item_new_with_label(menustr[barre_menu+1][opt.lang]);
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(item), SubmenuOption());
	gtk_menu_bar_append(GTK_MENU_BAR(mainmenu), item);
	gtk_widget_show(item);

	item=gtk_menu_item_new_with_label(menustr[barre_menu+2][opt.lang]);
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(item), SubmenuAide());
	gtk_menu_item_right_justify(GTK_MENU_ITEM(item));
	gtk_menu_bar_append(GTK_MENU_BAR(mainmenu), item);
	gtk_widget_show(item);
}

static void ChangeMainMenu() {
	GList *items=GTK_MENU_SHELL(mainmenu)->children;
	GList *child;
	
	if(items!=NULL) {
		gtk_menu_item_remove_submenu(GTK_MENU_ITEM(items->data));
		child=gtk_container_children(GTK_CONTAINER(items->data));
		gtk_label_set(GTK_LABEL(child->data), menustr[barre_menu][opt.lang]);
		gtk_menu_item_set_submenu(GTK_MENU_ITEM(items->data), SubmenuFichier());
		items=items->next;
	}

	if(items!=NULL) {
		gtk_menu_item_remove_submenu(GTK_MENU_ITEM(items->data));
		child=gtk_container_children(GTK_CONTAINER(items->data));
		gtk_label_set(GTK_LABEL(child->data), menustr[barre_menu+1][opt.lang]);
		gtk_menu_item_set_submenu(GTK_MENU_ITEM(items->data), SubmenuOption());
		items=items->next;
	}
	
	if(items!=NULL) {
		gtk_menu_item_remove_submenu(GTK_MENU_ITEM(items->data));
		child=gtk_container_children(GTK_CONTAINER(items->data));
		gtk_label_set(GTK_LABEL(child->data), menustr[barre_menu+2][opt.lang]);
		gtk_menu_item_set_submenu(GTK_MENU_ITEM(items->data), SubmenuAide());
		items=items->next;
	}

}
