/* Copyright (C) Emmanuel Varagnat 1998

   Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
   le modifier conformment aux dispositions de la Licence Publique Gnrale
   GNU, telle que publie par la Free Software Foundation ; version 2 de la
   licence, ou encore ( votre choix) toute version ultrieure.

   Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE
   GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION ou
   D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail, voir la Licence
   Publique Gnrale GNU .

   Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en
   mme temps que ce programme ; si ce n'est pas le cas, crivez  la Free
   Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.

  ==========================================================================

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

  ==========================================================================

   Ecrit par Emmanuel Varagnat (emmanuel.varagnat@altavista.net)  */

#include <unistd.h>
#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <sys/types.h>

#include <gtk/gtk.h>
#include <gdk/gdkkeysyms.h>

#include "types.h"
#include "arbo.h"
#include "config.h"
#include "dialogs.h"
#include "explore.h"
#include "files.h"
#include "propriete.h"
#include "rm_cmd.h"

void CreatePopup4File();
void CreatePopup4Dir();

static void popup_Copy(GtkWidget*, gpointer);
static void popup_Move(GtkWidget*, gpointer);
static void popup_TAR(GtkWidget*, gpointer);
static void popup_exec_fnc(GtkWidget*, gint);

extern char *menustr[][2];

GtkWidget *pop_file;
GtkWidget *pop_dir;

static void popup_Copy(GtkWidget *item, gpointer p) {
	GdkCursor *hand;
	
	flag_cmd=1;

	hand=gdk_cursor_new(GDK_HAND2);
	gdk_window_set_cursor (mainwin->window, hand);

	gtk_clist_set_selection_mode(GTK_CLIST(arbo), GTK_SELECTION_MULTIPLE);
	gtk_grab_add(scroll_arbo);
}

static void popup_Move(GtkWidget *item, gpointer p) {
	GdkCursor *hand;
	
	flag_cmd=2;

	hand=gdk_cursor_new(GDK_HAND2);
	gdk_window_set_cursor (mainwin->window, hand);

	gtk_clist_set_selection_mode(GTK_CLIST(arbo), GTK_SELECTION_MULTIPLE);
	gtk_grab_add(scroll_arbo);

/*	msg_dialog("Dplacer", "Fonction non disponible pour le moment.");*/
}

static void popup_Dup(GtkWidget *item, gpointer p) {
	msg_dialog("Duplique", "Fonction non disponible pour le moment.");
}

static void popup_TAR(GtkWidget *item, gpointer p) {
/*	char *lab[]={ "Oui", "Non", NULL };*/
	msg_dialog("Archive TAR", "Fonction non disponible pour le moment.");
/*	printf("val: %d\n", buttons_dialog("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwzyx", "Supprimer", lab));*/
}

static void popup_exec_fnc(GtkWidget *item, gint pos) {
	GList *p;
	pid_t pid;
	int cnt=0, aux=1, row;
	char **args=NULL, *nom;
	
	args=(char**)malloc(sizeof(char*));
	args[cnt++]=strdup(exec_tb[pos].arg[0]);

	while(exec_tb[pos].arg[aux]) {
		args=(char**)realloc(args, (cnt+1)*sizeof(char*));
		args[cnt++]=strdup(exec_tb[pos].arg[aux++]);
	}

	/* si le programme autorise l'ouverture de plusieurs fichiers simultanement */
	if(exec_tb[pos].multi) {

		/* Ajoute  la liste des arguments tous les fichiers */
		p=GTK_CLIST(filelst)->selection;
		while(p!=NULL) {
			row=(int)p->data;
			nom=((File_data*)gtk_clist_get_row_data(GTK_CLIST(filelst), row))->nom;

			args=(char**)realloc(args, (cnt+1)*sizeof(char*));
			args[cnt++]=strdup(nom);

			p=p->next;
		}

		args=(char**)realloc(args, (cnt+1)*sizeof(char*));
		args[cnt]=NULL;	

		switch(pid=fork()) {
			case 0:  
				 chdir(select_path);
				 if(execvp(exec_tb[pos].arg[0], args)==-1) perror("execvp");
				 exit(0);
				 break;
			case -1: perror("fork");
		}
	}
	else {
		/* alloue une nouvelle entree pour un nom de fichier *
	     * sinon execute 'n' fois le programme 		 */
		
		args=(char**)realloc(args, (cnt+2)*sizeof(char*));
		args[cnt+1]=NULL;

		p=GTK_CLIST(filelst)->selection;
		while(p!=NULL) {
			row=(int)p->data;
			nom=((File_data*)gtk_clist_get_row_data(GTK_CLIST(filelst), row))->nom;
			args[cnt]=strdup(nom);

			switch(pid=fork()) {
				case 0:  
					 chdir(select_path);
					 if(execvp(exec_tb[pos].arg[0], args)==-1) perror("execvp");
					 exit(0);
					 break;
				case -1: perror("fork");
			}
			free(args[cnt]);
			p=p->next;
		}
	}
}

void CreatePopup4File() {
	GtkWidget *item;

	pop_file=gtk_menu_new();
	
	/* Informations */
	item=gtk_menu_item_new_with_label(menustr[menu_fichier+4][opt.lang]);
	gtk_signal_connect(GTK_OBJECT (item), "activate",
                               GTK_SIGNAL_FUNC (ShowFileInfo), NULL);
	gtk_widget_add_accelerator (item, "activate", accel_group,
		GDK_I, GDK_Control_R, GTK_ACCEL_VISIBLE);
	gtk_menu_append(GTK_MENU(pop_file), item);
	gtk_widget_show(item);	

	item=gtk_menu_item_new();
	gtk_menu_append(GTK_MENU(pop_file), item);
	gtk_widget_show(item);	

	/* Copie */
	item=gtk_menu_item_new_with_label(menustr[menu_fichier+1][opt.lang]);
	gtk_signal_connect(GTK_OBJECT (item), "activate",
                               GTK_SIGNAL_FUNC (popup_Copy), NULL);
	gtk_menu_append(GTK_MENU(pop_file), item);
	gtk_widget_show(item);	

	/* Deplacement */
	item=gtk_menu_item_new_with_label(menustr[menu_fichier+2][opt.lang]);
	gtk_signal_connect(GTK_OBJECT (item), "activate",
                               GTK_SIGNAL_FUNC (popup_Move), NULL);
	gtk_menu_append(GTK_MENU(pop_file), item);
	gtk_widget_show(item);	

	/* Suppression */
	item=gtk_menu_item_new_with_label(menustr[menu_fichier+3][opt.lang]);
	gtk_signal_connect_object(GTK_OBJECT (item), "activate",
                               GTK_SIGNAL_FUNC (cmd_remove_files), (gpointer)select_path);
	gtk_menu_append(GTK_MENU(pop_file), item);
	gtk_widget_show(item);

	/* Duplique */
	item=gtk_menu_item_new_with_label("Duplique");
	gtk_signal_connect(GTK_OBJECT (item), "activate",
                               GTK_SIGNAL_FUNC (popup_Dup), NULL);
	gtk_menu_append(GTK_MENU(pop_file), item);
	gtk_widget_show(item);

	item=gtk_menu_item_new();
	gtk_menu_append(GTK_MENU(pop_file), item);
	gtk_widget_show(item);	

	if(exec_tb!=NULL) {
		GtkWidget *submenu;
		int pos=0;

		item=gtk_menu_item_new_with_label("Envoyer vers");
		gtk_menu_append(GTK_MENU(pop_file), item);
		gtk_widget_show(item);	

		submenu=gtk_menu_new();
		gtk_menu_item_set_submenu(GTK_MENU_ITEM(item), submenu);

		while(pos!=exec_pos) {
			item=gtk_menu_item_new_with_label(exec_tb[pos].arg[0]);
			gtk_signal_connect(GTK_OBJECT (item), "activate",
		                               GTK_SIGNAL_FUNC (popup_exec_fnc), (gpointer)exec_tb[pos].pos);
			gtk_menu_append(GTK_MENU(submenu), item);
			gtk_widget_show(item);	
			pos++;	
		}
		
		item=gtk_menu_item_new();
		gtk_menu_append(GTK_MENU(pop_file), item);
		gtk_widget_show(item);	
	}

	item=gtk_menu_item_new_with_label("Archive TAR");
	gtk_signal_connect(GTK_OBJECT (item), "activate",
                               GTK_SIGNAL_FUNC (popup_TAR), NULL);
	gtk_menu_append(GTK_MENU(pop_file), item);
	gtk_widget_show(item);	
}

void CreatePopup4Dir() {
	GtkWidget *item;

	pop_dir=gtk_menu_new();
	
	/* Informations */
	item=gtk_menu_item_new_with_label(menustr[menu_fichier+4][opt.lang]);
	gtk_signal_connect(GTK_OBJECT (item), "activate",
                               GTK_SIGNAL_FUNC (ShowDirInfo), NULL);
	gtk_menu_append(GTK_MENU(pop_dir), item);
	gtk_widget_show(item);	

	item=gtk_menu_item_new();
	gtk_menu_append(GTK_MENU(pop_dir), item);
	gtk_widget_show(item);	

	/* Copie */
	item=gtk_menu_item_new_with_label(menustr[menu_fichier+1][opt.lang]);
/*	gtk_signal_connect(GTK_OBJECT (item), "activate",
                               GTK_SIGNAL_FUNC (popup_Copy), NULL);*/
	gtk_menu_append(GTK_MENU(pop_dir), item);
	gtk_widget_show(item);	

	/* Deplacement */
	item=gtk_menu_item_new_with_label(menustr[menu_fichier+2][opt.lang]);
/*	gtk_signal_connect(GTK_OBJECT (item), "activate",
                               GTK_SIGNAL_FUNC (popup_Move), NULL);*/
	gtk_menu_append(GTK_MENU(pop_dir), item);
	gtk_widget_show(item);	

	/* Suppression */
	item=gtk_menu_item_new_with_label(menustr[menu_fichier+3][opt.lang]);
/*	gtk_signal_connect(GTK_OBJECT (item), "activate",
                               GTK_SIGNAL_FUNC (popup_Delete), NULL);*/
	gtk_menu_append(GTK_MENU(pop_dir), item);
	gtk_widget_show(item);
}

