/* Copyright (C) Emmanuel Varagnat 1998

   Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
   le modifier conformment aux dispositions de la Licence Publique Gnrale
   GNU, telle que publie par la Free Software Foundation ; version 2 de la
   licence, ou encore ( votre choix) toute version ultrieure.

   Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE
   GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION ou
   D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail, voir la Licence
   Publique Gnrale GNU .

   Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en
   mme temps que ce programme ; si ce n'est pas le cas, crivez  la Free
   Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis. 

  ==========================================================================

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  

  ==========================================================================

   Ecrit par Emmanuel Varagnat (emmanuel.varagnat@altavista.net)  */

#include <gtk/gtk.h>

#include "arbo.h"
#include "config.h"
#include "explore.h"
#include "files.h"


static GtkWidget *prefwin;
static struct option bak_opt;

void Pref_Dialog();
static void close_pref(GtkWidget*, gpointer);
static void OK_pref(GtkWidget *w, gpointer p);
static void mask_colonne_change(GtkWidget*, int);
static GtkWidget *Set_Affichage_File();
static GtkWidget *Set_Affichage_Dir();

static void close_pref(GtkWidget *w, gpointer p) {
	gtk_grab_remove(prefwin);
	gtk_widget_destroy(prefwin);
}

static void OK_pref(GtkWidget *w, gpointer p) {
	if(opt.colonne != bak_opt.colonne) {
		gtk_clist_clear(GTK_CLIST(filelst));
		gtk_widget_destroy(filelst);

		gtk_container_add (GTK_CONTAINER (scroll_clist), InitFileList());
		gtk_widget_show(filelst);
		Refresh_file_list(select_path);
	}
	gtk_grab_remove(prefwin);
	gtk_widget_destroy(prefwin);
}

static void mask_colonne_change(GtkWidget *widget, int mask) {
	opt.colonne=opt.colonne^mask;
}

static GtkWidget *Set_Affichage_File() {
	GtkWidget *tbl, *tblfrm;
	GtkWidget *frame;
	GtkWidget *c_hfile, *c_script, *c_typelink;
	GtkWidget *c_colonnes;

	tbl=gtk_table_new(4, 1, FALSE);
	gtk_container_border_width(GTK_CONTAINER(tbl), 5);
	
	c_hfile=gtk_check_button_new_with_label("Montrer fichiers cachs.");
	gtk_table_attach_defaults(GTK_TABLE(tbl), c_hfile, 0,1,0,1);
	gtk_widget_show(c_hfile);

	c_script=gtk_check_button_new_with_label("Diffrencier les scripts des binaires.");
	gtk_table_attach_defaults(GTK_TABLE(tbl), c_script, 0,1,1,2);
	gtk_widget_show(c_script);

	c_typelink=gtk_check_button_new_with_label("Liens symboliques du type du fichier cible.");
	gtk_table_attach_defaults(GTK_TABLE(tbl), c_typelink, 0,1,2,3);
	gtk_widget_show(c_typelink);
	
	frame=gtk_frame_new("Colonnes ");
	gtk_table_attach_defaults(GTK_TABLE(tbl), frame, 0,1,3,4);
	gtk_widget_show(frame);
	
	tblfrm=gtk_table_new(4, 3, FALSE);
	gtk_container_add(GTK_CONTAINER(frame), tblfrm);
	gtk_widget_show(tblfrm);
	
	c_colonnes=gtk_check_button_new_with_label("inode");
	if(opt.colonne & AFF_INOD) gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (c_colonnes), TRUE);
	gtk_table_attach_defaults(GTK_TABLE(tblfrm), c_colonnes, 0,1,0,1);
	gtk_signal_connect (GTK_OBJECT (c_colonnes), "clicked",
			GTK_SIGNAL_FUNC (mask_colonne_change), (gpointer)AFF_INOD);
	gtk_widget_show(c_colonnes);
	c_colonnes=gtk_check_button_new_with_label("nom");
	if(opt.colonne & AFF_NOM) gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (c_colonnes), TRUE);
	gtk_widget_set_sensitive(c_colonnes, FALSE);
	gtk_table_attach_defaults(GTK_TABLE(tblfrm), c_colonnes, 1,2,0,1);
	gtk_signal_connect (GTK_OBJECT (c_colonnes), "clicked",
			GTK_SIGNAL_FUNC (mask_colonne_change), (gpointer)AFF_NOM);
	gtk_widget_show(c_colonnes);
	c_colonnes=gtk_check_button_new_with_label("date de changement");
	if(opt.colonne & AFF_CTIME) gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (c_colonnes), TRUE);
	gtk_table_attach_defaults(GTK_TABLE(tblfrm), c_colonnes, 2,3,0,1);
	gtk_signal_connect (GTK_OBJECT (c_colonnes), "clicked",
			GTK_SIGNAL_FUNC (mask_colonne_change), (gpointer)AFF_CTIME);
	gtk_widget_show(c_colonnes);

	c_colonnes=gtk_check_button_new_with_label("droits");
	if(opt.colonne & AFF_PERM) gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (c_colonnes), TRUE);
	gtk_table_attach_defaults(GTK_TABLE(tblfrm), c_colonnes, 0,1,1,2);
	gtk_signal_connect (GTK_OBJECT (c_colonnes), "clicked",
			GTK_SIGNAL_FUNC (mask_colonne_change), (gpointer)AFF_PERM);
	gtk_widget_show(c_colonnes);
	c_colonnes=gtk_check_button_new_with_label("nbr. de liens");	
	if(opt.colonne & AFF_LNK) gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (c_colonnes), TRUE);
	gtk_table_attach_defaults(GTK_TABLE(tblfrm), c_colonnes, 1,2,1,2);
	gtk_signal_connect (GTK_OBJECT (c_colonnes), "clicked",
			GTK_SIGNAL_FUNC (mask_colonne_change), (gpointer)AFF_LNK);
	gtk_widget_show(c_colonnes);
	c_colonnes=gtk_check_button_new_with_label("date d'acces");
	if(opt.colonne & AFF_ATIME) gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (c_colonnes), TRUE);
	gtk_table_attach_defaults(GTK_TABLE(tblfrm), c_colonnes, 2,3,1,2);
	gtk_signal_connect (GTK_OBJECT (c_colonnes), "clicked",
			GTK_SIGNAL_FUNC (mask_colonne_change), (gpointer)AFF_ATIME);
	gtk_widget_show(c_colonnes);

	c_colonnes=gtk_check_button_new_with_label("UID");
	if(opt.colonne & AFF_UID) gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (c_colonnes), TRUE);
	gtk_table_attach_defaults(GTK_TABLE(tblfrm), c_colonnes, 0,1,2,3);
	gtk_signal_connect (GTK_OBJECT (c_colonnes), "clicked",
			GTK_SIGNAL_FUNC (mask_colonne_change), (gpointer)AFF_UID);
	gtk_widget_show(c_colonnes);
	c_colonnes=gtk_check_button_new_with_label("GID");
	if(opt.colonne & AFF_GID) gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (c_colonnes), TRUE);
	gtk_table_attach_defaults(GTK_TABLE(tblfrm), c_colonnes, 1,2,2,3);
	gtk_signal_connect (GTK_OBJECT (c_colonnes), "clicked",
			GTK_SIGNAL_FUNC (mask_colonne_change), (gpointer)AFF_GID);
	gtk_widget_show(c_colonnes);
	c_colonnes=gtk_check_button_new_with_label("date de modification");
	if(opt.colonne & AFF_MTIME) gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (c_colonnes), TRUE);
	gtk_table_attach_defaults(GTK_TABLE(tblfrm), c_colonnes, 2,3,2,3);
	gtk_signal_connect (GTK_OBJECT (c_colonnes), "clicked",
			GTK_SIGNAL_FUNC (mask_colonne_change), (gpointer)AFF_MTIME);
	gtk_widget_show(c_colonnes);
	
	c_colonnes=gtk_check_button_new_with_label("taille");
	if(opt.colonne & AFF_SIZE) gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (c_colonnes), TRUE);
	gtk_table_attach_defaults(GTK_TABLE(tblfrm), c_colonnes, 0,1,3,4);
	gtk_signal_connect (GTK_OBJECT (c_colonnes), "clicked",
			GTK_SIGNAL_FUNC (mask_colonne_change), (gpointer)AFF_SIZE);
	gtk_widget_show(c_colonnes);
	c_colonnes=gtk_check_button_new_with_label("nbr. de blocs");
	if(opt.colonne & AFF_BLOC) gtk_toggle_button_set_state (GTK_TOGGLE_BUTTON (c_colonnes), TRUE);
	gtk_table_attach_defaults(GTK_TABLE(tblfrm), c_colonnes, 1,2,3,4);
	gtk_signal_connect (GTK_OBJECT (c_colonnes), "clicked",
			GTK_SIGNAL_FUNC (mask_colonne_change), (gpointer)AFF_BLOC);
	gtk_widget_show(c_colonnes);

	return tbl;
}

static GtkWidget *Set_Affichage_Dir() {
	GtkWidget *tbl;
	GtkWidget *c_hdir, *c_link, *c_dir1st;

	tbl=gtk_table_new(2, 1, FALSE);
	
	c_hdir=gtk_check_button_new_with_label("Montrer rpertoires cachs.");
	gtk_table_attach_defaults(GTK_TABLE(tbl), c_hdir, 0,1,0,1);
	gtk_widget_show(c_hdir);

	c_link=gtk_check_button_new_with_label("Afficher les liens symboliques dans des bulles.");
	gtk_table_attach_defaults(GTK_TABLE(tbl), c_link, 0,1,1,2);
	gtk_widget_show(c_link);

	c_dir1st=gtk_check_button_new_with_label("Afficher les rpertoires en premier.");
	gtk_table_attach_defaults(GTK_TABLE(tbl), c_dir1st, 0,1,2,3);
	gtk_widget_show(c_dir1st);
	
	return tbl;
}

void Pref_Dialog() {
	GtkWidget *tbl;
	GtkWidget *notebook;
	GtkWidget *label;
	GtkWidget *affich_file, *affich_dir;
	GtkWidget *b_Ok, *b_Annul;
	
	bak_opt=opt;
	
	prefwin=gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(prefwin), "Preferences");
	gtk_signal_connect (GTK_OBJECT (prefwin), "delete_event",
                               GTK_SIGNAL_FUNC (close_pref), NULL);
	gtk_container_border_width(GTK_CONTAINER(prefwin), 5);
	gtk_widget_realize(prefwin);

	tbl=gtk_table_new(2, 2, FALSE);
	gtk_container_add(GTK_CONTAINER(prefwin), tbl);
	gtk_widget_show(tbl);

	notebook = gtk_notebook_new ();
	gtk_notebook_set_tab_pos (GTK_NOTEBOOK (notebook), GTK_POS_TOP);
	gtk_table_attach_defaults(GTK_TABLE(tbl), notebook, 0,2,0,1);
	gtk_widget_show(notebook);

	affich_file=Set_Affichage_File();
	label=Pixmaped_label_item(" Fichiers", pix_file, msk_file);
	gtk_notebook_append_page (GTK_NOTEBOOK (notebook), affich_file, label);
	gtk_widget_show(affich_file);

	affich_dir=Set_Affichage_Dir();
	label=Pixmaped_label_item(" Repertoires", pix_dir, msk_dir);
	gtk_notebook_append_page (GTK_NOTEBOOK (notebook), affich_dir, label);
	gtk_widget_show(affich_dir);

	b_Ok=gtk_button_new_with_label("Ok");
	gtk_table_attach(GTK_TABLE(tbl), b_Ok, 0,1,1,2, GTK_FILL, GTK_FILL, 10, 5);
	gtk_signal_connect (GTK_OBJECT (b_Ok), "clicked",
        	                       GTK_SIGNAL_FUNC (OK_pref), NULL);
	gtk_widget_show(b_Ok);
	b_Annul=gtk_button_new_with_label("Annuler");
	gtk_table_attach(GTK_TABLE(tbl), b_Annul, 1,2,1,2, GTK_FILL, GTK_FILL, 10, 5);
	gtk_signal_connect (GTK_OBJECT (b_Annul), "clicked",
        	                       GTK_SIGNAL_FUNC (close_pref), NULL);
	gtk_widget_show(b_Annul);

	gtk_widget_show(prefwin);
	
	gtk_grab_add(prefwin);
}
