/* `rm' file deletion utility for GNU.
   Copyright (C) 88, 90, 91, 94, 95, 1996 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  

  ==========================================================================

   Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou
   le modifier conformment aux dispositions de la Licence Publique Gnrale
   GNU, telle que publie par la Free Software Foundation ; version 2 de la
   licence, ou encore ( votre choix) toute version ultrieure.

   Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE
   GARANTIE ; sans mme la garantie implicite de COMMERCIALISATION ou
   D'ADAPTATION A UN OBJET PARTICULIER. Pour plus de dtail, voir la Licence
   Publique Gnrale GNU .

   Vous devez avoir reu un exemplaire de la Licence Publique Gnrale GNU en
   mme temps que ce programme ; si ce n'est pas le cas, crivez  la Free
   Software Foundation Inc., 675 Mass Ave, Cambridge, MA 02139, Etats-Unis.

  ==========================================================================

   Written by Paul Rubin, David MacKenzie, and Richard Stallman.
   From GNU file utils 3.16.

   Modified and cleaned for my use (modifi et nettoy pour mon usage).
   Copyright (C) 1998 - Emmanuel Varagnat (emmanuel.varagnat@altavista.net) */

#include <gtk/gtk.h>
/* #include <config.h> */
#include <malloc.h>
#include <stdio.h>
/* #include <getopt.h> */
#include <sys/types.h>
#include <sys/stat.h>

#include <unistd.h>
#include <errno.h>
#include <string.h>

#include <dirent.h>
# define NLENGTH(direct) (strlen((direct)->d_name))
#define CLOSEDIR(d) closedir (d)

/*#include "system.h"
 #include "error.h" */
#include "types.h"
#include "arbo.h"
#include "config.h"
#include "dialogs.h"
#include "files.h"

#ifdef D_INO_IN_DIRENT
# define D_INO(dp) ((dp)->d_ino)
#else*/
/* Some systems don't have inodes, so fake them to avoid lots of ifdefs.  */
# define D_INO(dp) 1
#endif

/* An element in a stack of pointers into `pathname'.
   `pathp' points to where in `pathname' the terminating '\0' goes
   for this level's directory name.  */
struct pathstack
{
  struct pathstack *next;
  char *pathp;
  ino_t inum;
};

char *basename ();
char *stpcpy ();
char *xmalloc ();
char *xrealloc ();
int euidaccess ();
int yesno ();
void strip_trailing_slashes ();

static int clear_directory __P ((struct stat *statp));
static int duplicate_entry __P ((struct pathstack *stack, ino_t inum));
static int remove_dir __P ((struct stat *statp));
static int remove_file __P ((struct stat *statp));
static int rm __P ((void));

/* Linked list of pathnames of directories in progress in recursive rm.
   The entries actually contain pointers into `pathname'.
   `pathstack' is the current deepest level.  */
static struct pathstack *pathstack = NULL;

/* Path of file now being processed; extended as necessary.  */
static char *pathname;

/* Number of bytes currently allocated for `pathname';
   made larger when necessary, but never smaller.  */
static int pnsize;

/* If nonzero, display the name of each file removed.  */
static int verbose;

/* If nonzero, ignore nonexistant files.  */
static int ignore_missing_files;

/* If nonzero, recursively remove directories.  */
static int recursive;

static int interactive;

static int unlink_dirs;


int remove_all;
int override_all;

/************************* GTK **************************/
/*static GtkWidget *merrorwin=NULL;*/
static GtkWidget *rm_win;
static GtkWidget *errlst;
static GtkWidget *label;

static void close_rmwin(GtkWidget *widg, gpointer p) {
	gtk_grab_remove(rm_win);
	gtk_widget_destroy(rm_win);
}

static void add_error(char *file, char *msg) {
	char *row[2];

	if (!GTK_WIDGET_VISIBLE(errlst)) {
		gtk_widget_show(errlst);
	}
	gtk_clist_freeze(GTK_CLIST(errlst));
	row[0]=file;
	row[1]=msg;
	gtk_clist_append(GTK_CLIST(errlst), row);
	gtk_clist_thaw(GTK_CLIST(errlst));

/*	while (gtk_events_pending())
	    gtk_main_iteration();*/
}

void cmd_remove_files(char *path) {
	GtkWidget *vbox;
	GtkWidget *button;
	GtkWidget *sep;
	GList *p;
	gint row;
	char *nom, *lab[]={"Oui", "Non", NULL}, *tt[2]={ " ", " "};
	int len, err, nb_err=0;

	verbose = interactive = unlink_dirs = recursive = 0;
	ignore_missing_files = 1;
	remove_all = override_all = 0;
	pnsize = 256;
	pathname = xmalloc (pnsize);
	if(chdir(path)!=0) {
	     return;
	}

	if(buttons_dialog("Etes-vous sur(e)de vouloir supprimer ces fichiers", "Supprimer", lab))
		return;

	rm_win = gtk_window_new( GTK_WINDOW_DIALOG );
	gtk_window_set_title(GTK_WINDOW(rm_win), "Supprimer");
	gtk_window_position( GTK_WINDOW(rm_win), GTK_WIN_POS_CENTER );
	gtk_widget_set_usize(rm_win, 380, 0);
	gtk_signal_connect (GTK_OBJECT (rm_win), "delete_event",
	                       GTK_SIGNAL_FUNC (close_rmwin), NULL);
	gtk_container_border_width(GTK_CONTAINER(rm_win), 10);
	gtk_widget_realize(rm_win);

	vbox=gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(rm_win), vbox);
	gtk_widget_show(vbox);

	label=gtk_label_new("POUET");
	gtk_box_pack_start(GTK_BOX(vbox), label, FALSE, TRUE, 4);
	gtk_widget_show(label);

	button=gtk_button_new_with_label("Annuler");
	gtk_signal_connect (GTK_OBJECT (button), "clicked",
	                       GTK_SIGNAL_FUNC (close_rmwin), NULL);
	gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 4);
	gtk_widget_show(button);

	sep=gtk_hseparator_new();
	gtk_box_pack_start(GTK_BOX(vbox), sep, FALSE, TRUE, 4);
	gtk_widget_hide(sep);

	errlst=gtk_clist_new_with_titles(2, tt);
	gtk_clist_column_titles_show(GTK_CLIST(errlst));
/*	gtk_clist_set_selection_mode(GTK_CLIST(errlst), GTK_SELECTION_EXTENDED);*/
	gtk_clist_set_column_width(GTK_CLIST(errlst), 0, 120);
	gtk_box_pack_start(GTK_BOX(vbox), errlst, TRUE, TRUE, 4);
	gtk_widget_hide(errlst);

	gtk_grab_add(rm_win);

	gtk_widget_realize(vbox);
	gtk_widget_realize(sep);
	gtk_widget_realize(errlst);
	gtk_widget_show(rm_win);

	p=GTK_CLIST(filelst)->selection;
	while(p!=NULL) {
		row=(int)p->data;
		nom=strdup(((File_data*)gtk_clist_get_row_data(GTK_CLIST(filelst), row))->nom);

 		strip_trailing_slashes (nom);
		len = strlen (nom);
		if (len + 1 > pnsize)
		  {
		    free (pathname);
		    pnsize = 2 * (len + 1);
		    pathname = xmalloc (pnsize);
		  }
		strcpy (pathname, nom);
		free(nom);
		err=rm();
		if(err) {
		    if(err == 2)
			break;
		    else
			nb_err++;
		    p=p->next;
		}
		else {
		    p=p->next;
		    gtk_clist_remove(GTK_CLIST(filelst), row);
		}		  
	}

	if(!nb_err) {
	     gtk_grab_remove(rm_win);
	     gtk_widget_destroy(rm_win);
	}
}

/*********************GTK****************************/

/* renvoie 1 si erreur 0 sinon, et 2 si on ne doit pas continuer */
static int
rm (void)
{
  struct stat path_stats;
  char *base = basename (pathname);

  if (base[0] == '.' && (base[1] == '\0'
			     || (base[1] == '.' && base[2] == '\0')))
    {
      add_error(".", "ne peut effacer `.' ou `..'");
      return 1;
    }

  if (lstat (pathname, &path_stats)
      || (pathname[0] == '\0' && (errno = ENOENT)))
    {
      if (errno == ENOENT && ignore_missing_files)
	return 0;
      add_error(pathname, strerror(errno));
      return 1;
    }

  if (S_ISDIR (path_stats.st_mode) && !unlink_dirs)
    return remove_dir (&path_stats);
  else
    return remove_file (&path_stats);
}



/* Query the user if appropriate, and if ok try to remove the
   non-directory `pathname', which STATP contains info about.
   Return 0 if `pathname' is removed, 1 if not.  */

static int
remove_file (struct stat *statp)
{
  
/* !ignore_missing_file toujours FAUX */
  if (!override_all /*!ignore_missing_files && (interactive || stdin_tty)*/
      && euidaccess (pathname, W_OK)
#ifdef S_ISLNK
      && !S_ISLNK (statp->st_mode)
#endif
      )
    {
	char txt[100], *lab[]={ "Oui", "Non", "Tout", "Annuler", NULL };
	sprintf(txt, "Remove %s`%s', overriding mode %04o? ",
	       S_ISDIR (statp->st_mode) ? "directory " : "",
	       pathname,
	       (unsigned int) (statp->st_mode & 07777));
	switch(buttons_dialog(txt, "Supprimer", lab)) {
	   /*Non*/   case 1: return 0;
	   /*Tout*/  case 2:
	   		override_all=1;
	   		break;
	   /*Annuler*/case 3:
	   		return 2;
	   		break;
	}
    }

  gtk_label_set_text(GTK_LABEL(label), pathname);

  if (unlink (pathname) && (errno != ENOENT /*|| !ignore_missing_files*/))
    {
      add_error(pathname, strerror(errno));
      return 1;
    }
  return 0;
}



/* If not in recursive mode, print an error message and return 1.
   Otherwise, query the user if appropriate, then try to recursively
   remove directory `pathname', which STATP contains info about.
   Return 0 if `pathname' is removed, 1 if not.  */

static int
remove_dir (struct stat *statp)
{
  int err;

  if (!recursive)
    {
	char txt[100], *lab[]={ "Oui", "Non", "Tout", "Annuler", NULL };
	sprintf(txt, "Effacer le contenu de %s ?", pathname);
	switch(buttons_dialog(txt, "Supprimer", lab)) {
	   /*Non*/   case 1: return 0;
	   /*Tout*/  case 2:
	   		recursive=1;
	   		break;
	   /*Annuler*/case 3:
	   		return 2;
	   		break;
	}
    }

/* !ignore_missing_file toujours FAUX */
  if (!override_all /*!ignore_missing_files && (interactive || stdin_tty)*/
      && euidaccess (pathname, W_OK))
    {
	char txt[100], *lab[]={ "Oui", "Non", "Tout", "Annuler", NULL };
	sprintf(txt, "Remove %s`%s', overriding mode %04o? ",
	       S_ISDIR (statp->st_mode) ? "directory " : "",
	       pathname,
	       (unsigned int) (statp->st_mode & 07777));
	switch(buttons_dialog(txt, "Supprimer", lab)) {
	   /*Non*/   case 1: return 0;
	   /*Tout*/  case 2:
	   		override_all=1;
	   		break;
	   /*Annuler*/case 3:
	   		return 2;
	   		break;
	}
    }

  gtk_label_set_text(GTK_LABEL(label), pathname);

  err = clear_directory (statp);

  if (rmdir (pathname) && (errno != ENOENT /*|| !ignore_missing_files*/))
    {
      add_error(pathname, strerror(errno));
      return 1;
    }
  return 0;
}



/* Read directory `pathname' and remove all of its entries,
   avoiding use of chdir.
   On entry, STATP points to the results of stat on `pathname'.
   Return 0 for success, error count for failure.
   Upon return, `pathname' will have the same contents as before,
   but its address might be different; in that case, `pnsize' will
   be larger, as well.  */

static int
clear_directory (struct stat *statp)
{
  DIR *dirp;
  struct dirent *dp;
  char *name_space;		/* Copy of directory's filenames.  */
  char *namep;			/* Current entry in `name_space'.  */
  unsigned name_size;		/* Bytes allocated for `name_space'.  */
  int name_length;		/* Length of filename in `namep' plus '\0'.  */
  int pathname_length;		/* Length of `pathname'.  */
  ino_t *inode_space;		/* Copy of directory's inodes.  */
  ino_t *inodep;		/* Current entry in `inode_space'.  */
  unsigned n_inodes_allocated;	/* There is space for this many inodes
					  in `inode_space'.  */
  int err = 0;			/* Return status.  */
  struct pathstack pathframe;	/* New top of stack.  */
  struct pathstack *pp;		/* Temporary.  */

  name_size = statp->st_size;
  name_space = (char *) xmalloc (name_size);

  n_inodes_allocated = (statp->st_size + sizeof (ino_t) - 1) / sizeof (ino_t);
  inode_space = (ino_t *) xmalloc (n_inodes_allocated * sizeof (ino_t));

  do
    {
      namep = name_space;
      inodep = inode_space;

      errno = 0;
      dirp = opendir (pathname);
      if (dirp == NULL)
	{
	  if (errno != ENOENT/* || !ignore_missing_files*/)
	    {
              add_error(pathname, strerror(errno)); 
	      err = 1;
	    }
	  free (name_space);
	  free (inode_space);
	  return err;
	}

      while ((dp = readdir (dirp)) != NULL)
	{
	  /* Skip "." and "..".  */
	  if (dp->d_name[0] != '.'
	      || (dp->d_name[1] != '\0'
		  && (dp->d_name[1] != '.' || dp->d_name[2] != '\0')))
	    {
	      unsigned size_needed = (namep - name_space) + NLENGTH (dp) + 2;

	      if (size_needed > name_size)
		{
		  char *new_name_space;

		  while (size_needed > name_size)
		    name_size += 1024;

		  new_name_space = xrealloc (name_space, name_size);
		  namep += new_name_space - name_space;
		  name_space = new_name_space;
		}
	      namep = stpcpy (namep, dp->d_name) + 1;

	      if (inodep == inode_space + n_inodes_allocated)
		{
		  ino_t *new_inode_space;

		  n_inodes_allocated += 1024;
		  new_inode_space = (ino_t *) xrealloc (inode_space,
					n_inodes_allocated * sizeof (ino_t));
		  inodep += new_inode_space - inode_space;
		  inode_space = new_inode_space;
		}
	      *inodep++ = D_INO (dp);
	    }
	}
      *namep = '\0';
      if (CLOSEDIR (dirp))
	{
          add_error(pathname, strerror(errno));
/*	  err = 1;*/
	}

      pathname_length = strlen (pathname);

      for (namep = name_space, inodep = inode_space; *namep != '\0';
	   namep += name_length, inodep++)
	{
	  name_length = strlen (namep) + 1;

	  /* Handle arbitrarily long filenames.  */
	  if (pathname_length + 1 + name_length > pnsize)
	    {
	      char *new_pathname;

	      pnsize = (pathname_length + 1 + name_length) * 2;
	      new_pathname = xrealloc (pathname, pnsize);
	      /* Update all pointers in the stack to use the new area.  */
	      for (pp = pathstack; pp != NULL; pp = pp->next)
		pp->pathp += new_pathname - pathname;
	      pathname = new_pathname;
	    }

	  /* Add a new frame to the top of the path stack.  */
	  pathframe.pathp = pathname + pathname_length;
	  pathframe.inum = *inodep;
	  pathframe.next = pathstack;
	  pathstack = &pathframe;

	  /* Append '/' and the filename to current pathname, take care of
	     the file (which could result in recursive calls), and take
	     the filename back off.  */

	  *pathstack->pathp = '/';
	  strcpy (pathstack->pathp + 1, namep);

	  /* If the i-number has already appeared, there's an error.  */
	  err=duplicate_entry(pathstack->next, pathstack->inum);
	  if(err == 1)
	       break;

	  err=rm();
	  *pathstack->pathp = '\0';
	  pathstack = pathstack->next;	/* Pop the stack.  */
	  if(err == 2)
	       break;
	}
    }
  /* Keep trying while there are still files to remove.  */
  while (namep > name_space && err == 0);

  free (name_space);
  free (inode_space);
  return err;
}



/* If STACK does not already have an entry with the same i-number as INUM,
   return 0. Otherwise, ask the user whether to continue;
   if yes, return 1, and if no, exit.
   This assumes that no one tries to remove filesystem mount points;
   doing so could cause duplication of i-numbers that would not indicate
   a corrupted file system.  */

static int
duplicate_entry (struct pathstack *stack, ino_t inum)
{
#ifdef D_INO_IN_DIRENT
  struct pathstack *p;

  for (p = stack; p != NULL; p = p->next)
    {
      if (p->inum == inum)
	{
	  char text[500];
	  char txt[100], *lab[]={ "Oui", "Non", NULL };

	  sprintf (text, "\
WARNING: Circular directory structure.\n\
This almost certainly means that you have a corrupted file system.\n\
NOTIFY YOUR SYSTEM MANAGER.\n\
Cycle detected:\n\
%s\n\
is the same file as\n", pathname);
	  *p->pathp = '\0';	/* Truncate pathname.  */
	  strcat (text, pathname);
	  strcat (text, "\n");
	  *p->pathp = '/';	/* Put it back.  */
	  strcat(text, "\nContinue?");

	  switch(buttons_dialog(text, "Supprimer", lab)) {
	     /*Non*/   case 1: return 2;
	  }
	}
    }
#endif /* D_INO_IN_DIRENT */
  return 0;
}

